<?php

// getdat.php
// Nigel Whitfield, 2005
// version 0.2

// 0.2 - for use with MacTF-EPG, set $status to true
//       to output progress information during retrieval
// 0.1 - original version

// PHP script to fetch RadioTimes channel listing .dat files
// Radio Times listings are for personal use only

// Designed for Mac OS X

$status = true ;

// start by reading channelmap.ini

$ini = fopen( 'channelmap.ini', 'r' ) 
	or die("Unable to open channelmap.ini\n") ;

do {
	if ( preg_match('/^#/', $iniline)) {
		// do nothing
	} elseif ( preg_match('/(.+)\s+(\d+)/', $iniline, $matches)) {
		$dat[$matches[1]] = $matches[2] ;
	}

} while ($iniline = fgets( $ini )) ;

fclose($ini) ;

// is there a command line parameter given?

if ( $argv[1] != '' ) {
	// channel name given
	if ( isset($dat[$argv[1]]) ) {
		store_channel($argv[1]) ;
	} else {
		print "No Radio Times id for $argv[1]\n" ;
	}
} else {

// work through the list of channels to fetch

	if ( $status ) {
		print "Fetching " . count($dat) . " channels\n" ;
	}

	foreach ( array_keys($dat) as $channel ) {
		store_channel($channel) ;
		$status && print ".\n" ;
	}
}
exit ;

function store_channel($ch) {
global $dat ;

	$url = sprintf("http://xmltv.radiotimes.com/xmltv/%s.dat", $dat[$ch]) ;
	$output = sprintf("channels/%s.dat", $ch) ;

	$datfile = fopen( $output, 'w' ) or die("Can't open output file for $ch\n") ;

	$epgdata = file_get_contents($url) ;

	fwrite($datfile, $epgdata) ;
	fclose($datfile) ;
}

?>
